/* fork.c
 * SommerCampus 2006 */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

void child_proc()
{
	printf("child: I am the nice child process. My pid = %d and dady's pid = %d\n", getpid(), getppid());

	printf("child: I don't really know, what is my father talking about? I am *not* noisy\n");

	printf("child: Typical, I want to go to my bed and sleep some time\n");

	sleep(10);

	printf("child: Good Morging World ..... Dad is still angry, I guess...\n");

	printf("child: At school, English is so boring, I want to ... sleep ...\n");

	sleep(2);
	
	printf("child: hm???\n");
}

void parent_proc(pid_t child)
{
	printf("parent: I am the parent process. My pid = %d and my child's pid = %d\n", getpid(), child);

	printf("parent: My silly child is too noisy... I'm going to sleep 3 seconds\n");

	sleep(3);

	printf("parent: Back to live! This child does not behave properly. It must be punished\n");
	printf("parent: sleeping again...\n");

	sleep(5);

	printf("parent: bye bye\n");
}

int main(void)
{
	pid_t child;

	child = fork();

	if(child == -1)
	{
		fprintf(stderr, "could not create a new process\n");
		return 1;
	} else if(child == 0)
		child_proc();
	else
		parent_proc(child);

	return 0;
}
