/* vfork.c
 * SommerCampus 2006 */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(void)
{
	int a = 10;
	pid_t child;

	printf("a = %d\n", a);
	fflush(NULL);

	child = fork();

	if(child == -1)
	{
		fprintf(stderr, "could no create new process\n");
		return 1;
	} else if(child == 0)
	{
		printf("child1: a = %d\n", a);
		sleep(3);
		a = 110;
		printf("child1: a = %d\n", a);
		fflush(NULL);

		exit(0); /* der Rest des Prozess muss vom Kind nicht ausgefhrt werden */
		
	} else {
		wait(NULL); /* Warte auf Kind */

		printf("parent: a = %d\n", a);
		fflush(NULL);
	}

	printf("\n=================================== \n\n");


	child = vfork();


	if(child == -1)
        {
                fprintf(stderr, "could no create new process\n");
                return 1;
        } else if(child == 0)
        {
                printf("child2: a = %d\n", a);
                sleep(3);
                a = 110;
                printf("child2: a = %d\n", a);
                fflush(NULL);

                exit(0); /* der Rest des Prozess muss vom Kind nicht ausgefhrt werden */
                
        } else {
                wait(NULL); /* Warte auf Kind */

                printf("parent: a = %d\n", a);
                fflush(NULL);
        }

	return 0;
}
